Index: /trunk/scripts/samhainadmin.pl.in
===================================================================
--- /trunk/scripts/samhainadmin.pl.in	(revision 1)
+++ /trunk/scripts/samhainadmin.pl.in	(revision 1)
@@ -0,0 +1,612 @@
+#! /usr/bin/perl
+
+# Copyright Rainer Wichmann (2004)
+#
+# License Information:
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+#
+
+use warnings;
+use strict;
+use Getopt::Long;
+use File::Basename;
+use File::stat;
+use File::Temp qw/ tempfile tempdir unlink0 /;
+use IO::Handle;
+
+File::Temp->safe_level( File::Temp::HIGH );
+
+my %opts = ();
+my $action;
+my $file1;
+my $file2;
+my $passphrase;
+my $return_from_sign = 0;
+my $no_print_examine = 0;
+my $base = basename($0);
+
+my $cfgfile  = "@myconffile@";
+my $datafile = "@mydatafile@";
+my $daemon   = "@sbindir@/@install_name@";
+my $gpg      = "@mygpg@";
+
+$gpg = "gpg" if ($gpg eq "");
+
+sub usage() {
+    print "Usage:\n";
+    print "  $base { -m F | --create-cfgfile }    [options] [in.cfgfile]\n";
+    print "    Sign the configuration file. If in.cfgfile is given, sign it\n";
+    print "    and install it as configuration file.\n\n";
+
+    print "  $base { -m f | --print-cfgfile }     [options] \n";
+    print "    Print the configuration file to stdout. Signatures are removed.\n\n";
+
+    print "  $base { -m D | --create-datafile }   [options] [in.datafile]\n";
+    print "    Sign the database file. If in.datafile is given, sign it\n";
+    print "    and install it as database file.\n\n";
+
+    print "  $base { -m d | --print-datafile }    [options] \n";
+    print "    Print the database file to stdout. Signatures are removed. Use\n";
+    print "    option --list to list files in database rather than printing the raw file.\n\n";
+
+    print "  $base { -m R | --remove-signature }  [options] file1 [file2 ...]\n";
+    print "    Remove cleartext signature from input file(s). The file\n";
+    print "    is replaced by the non-signed file.\n\n";
+
+    print "  $base { -m E | --sign }              [options] file1 [file2 ...]\n";
+    print "    Sign file(s) with a cleartext signature. The file\n";
+    print "    is replaced by the signed file.\n\n";
+
+    print "  $base { -m e | --examine }           [options] file1 [file2 ...]\n";
+    print "    Report signature status of file(s).\n\n";
+
+    print "  $base { -m G | --generate-keys }     [options] \n";
+    print "    Generate a PGP keypair to use for signing.\n\n";
+
+    print "Options:\n";
+    print "  -c cfgfile    --cfgfile cfgfile\n";
+    print "    Select an alternate configuration file.\n\n";
+
+    print "  -d datafile   --datafile datafile\n";
+    print "    Select an alternate database file.\n\n";
+
+    print "  -p passphrase --passphrase passphrase\n";
+    print "    Set the passphrase for gpg. By default, gpg will ask.\n\n";
+
+    print "  -l            --list\n";
+    print "    List the files in database rather than printing the raw file.\n\n";
+
+    print "  -v            --verbose\n";
+    print "    Verbose output.\n\n";
+    return;
+}
+
+sub check_gpg_uid () {
+    if (0 != $>) {
+	print "--------------------------------------------------\n";
+	print "\n";
+	print " You are not root. Please remember that samhain/yule\n";
+	print " will use the public keyring of root to verify a signature.\n";
+	print "\n";
+	print "--------------------------------------------------\n";
+    } else {
+	if (!("@yulectl_prg@" =~ //)) {
+	    print "--------------------------------------------------\n";
+	    print "\n";
+	    print " Please remember that yule will drop root after startup. Signature\n";
+	    print " verification on SIGHUP will fail if you do not import the public key\n";
+	    print " into the keyring of the non-root yule user.\n";
+	    print "\n";
+	    print "--------------------------------------------------\n";
+	}
+    }
+}
+    
+sub check_gpg_sign () {
+    if ( (!-d "$ENV{'HOME'}/.gnupg") || (!-e "$ENV{'HOME'}/.gnupg/secring.gpg")) {
+	print "--------------------------------------------------\n";
+	print "\n";
+	if (!-d "$ENV{'HOME'}/.gnupg") {
+	    print " Directory \$HOME/.gnupg not found!\n";
+	} else {
+	    print " Secret keyring \$HOME/.gnupg/secring.gpg not found!\n";
+	}
+	print "\n";
+	print " This indicates that you have never created a \n";
+	print " public/private keypair, and thus cannot sign.\n";
+	print " \n";
+	print " Please use $0 --generate-keys or gpg --gen-key\n";
+	print " to generate a public/private keypair first.\n";
+	print "\n";
+	print "--------------------------------------------------\n";
+	print "\n";
+	exit;
+    }
+}
+
+sub check_gpg_verify () {
+    if ( (!-d "$ENV{'HOME'}/.gnupg") || (!-e "$ENV{'HOME'}/.gnupg/pubring.gpg")) {
+	print "--------------------------------------------------\n";
+	print "\n";
+	if (!-d "$ENV{'HOME'}/.gnupg") {
+	    print " Directory \$HOME/.gnupg not found!\n";
+	} else {
+	    print " Public keyring \$HOME/.gnupg/pubring.gpg not found!\n";
+	}
+	print "\n";
+	print " This indicates that you have never used gpg before \n";
+	print " and/or have no public keys to verify signatures.\n";
+	print " \n";
+	print " Please use 'gpg --export key_id' to export the public\n";
+	print " signing key of the user who is signing the\n";
+	print " configuration/database files.\n\n";
+	print " Then you can use 'gpg --import keyfile' to import the key\n";
+	print " into this user's public keyring.\n";
+	print "\n";
+	print "--------------------------------------------------\n";
+	print "\n";
+	exit;
+    }
+}
+
+
+sub generate () {
+    my $command = "$gpg --homedir $ENV{'HOME'}/.gnupg --gen-key";
+    check_gpg_uid();
+    system ($command) == 0 
+	or die "system $command failed: $?";
+    exit;
+}
+
+sub examine () {
+    my $iscfg = 0;
+    my $have_fp  = 0;
+    my $have_sig = 0;
+    my $message = '';
+    my $retval  = 9;
+    my $fh;
+    my $filename;
+
+    if (!($file1 =~ /^\-$/)) {
+	die ("Cannot open $file1 for read: $!") unless ((-e $file1) && (-r _));
+    }
+    open FIN,  "<$file1" or die "Cannot open $file1 for read: $!";
+
+    my $dir = tempdir( CLEANUP => 1 );
+    $filename = $dir . "/exa_jhfdbilw";
+    open $fh, ">$filename" or die "Cannot open $filename";
+    autoflush $fh 1;
+
+    while (<FIN>) {
+	print $fh $_;
+	if ($_ =~ /^\s*\[Misc\]/) {
+	    $iscfg = 1;
+	}
+    }
+    if ($iscfg == 1) {
+	$message .=  "File $file1 is a configuration file\n\n";
+    } else {
+	$message .=  "File $file1 is a database file\n\n";
+    }
+
+
+    my $command = "$gpg --homedir $ENV{'HOME'}/.gnupg --status-fd 1 ";
+    $command .= "--verbose " if (defined($opts{'v'}));
+    $command .= "--verify $filename ";
+    if (defined($opts{'v'})) {
+	$command .= "2>&1";
+    } else {
+	$command .= "2>/dev/null";
+    }
+
+    print STDOUT "Using: $command\n\n" if (defined($opts{'v'}));
+    open  GPGIN, "$command |" or die "Cannot fork: $!";
+
+    while (<GPGIN>) {
+	if ($_ =~ /^\[GNUPG:\] GOODSIG ([0-9A-F]+) (.*)$/) {
+	    $message .= "GOOD signature with key: $1\n";
+	    $message .= "Key owner:               $2\n";
+	    $have_sig = 1;
+	    $retval   = 0;
+	}
+	if ($_ =~ /^\[GNUPG:\] VALIDSIG ([0-9A-F]+) ([0-9\-]+)\s/) {
+	    $message .= "Key fingerprint:         $1\n";
+	    $message .= "Signature generated on:  $2\n\n";
+	    $have_fp = 1;
+	    $message .=  "This file is signed with a valid signature.\n" 
+		if ($have_sig == 1);
+	    $have_sig = 1;
+	    $have_fp = 1;
+	}
+	if ($_ =~ /^\[GNUPG:\] NODATA 1/) {
+	    $message .=  "NO signature found.\n\n";
+	    $message .=  "This file is not signed !!!\n";
+	    $have_sig = 1;
+	    $have_fp = 1;
+	    $retval  = 2;
+	}
+	if ($_ =~ /^\[GNUPG:\] BADSIG ([0-9A-F]+) (.*)$/) {
+	    $message .=  "BAD signature with key: $1\n";
+	    $message .=  "Key owner:              $2\n\n";
+	    $message .=  "This file is signed with an invalid signature !!!\n";
+	    $have_sig = 1;
+	    $have_fp = 1;
+	    $retval = 1;
+	}
+	if ($_ =~ /^\[GNUPG:\] NO_PUBKEY ([0-9A-F]+)/) {
+	    $message .=  "NOT CHECKED signature with key: $1\n\n";
+	    $message .=  "The signature of this file cannot be checked: no public key available !!!\n";
+	    $have_sig = 1;
+	    $have_fp = 1;
+	    $retval  = 1;
+	}
+	print STDOUT $_ if (defined($opts{'v'}));
+    }
+    close (GPGIN);
+    print STDOUT "\n" if (defined($opts{'v'}));
+    if ($have_sig == 0) {
+	$message .=  "NO valid signature found\n";
+    } 
+    elsif ($have_fp == 0) {
+	$message .=  "NO fingerprint found\n";
+    }
+    close (FIN);
+    if ($no_print_examine == 0) {
+	print STDOUT $message;
+    }
+    unlink0( $fh, $filename ) or die "Cannot unlink $filename safely";
+    return $retval;
+}
+
+sub remove () {
+    my $bodystart = 1;
+    my $sigstart  = 0;
+    my $sigend    = 0;
+    my $filename  = "";
+    my $fh;
+    my $stats;
+
+    open FH, "<$file1" or die "Cannot open file $file1 for read: $!";
+    if (!($file1 =~ /^\-$/)) {
+	my $dir = tempdir( CLEANUP => 1 ) or die "Tempdir failed";
+	$filename = $dir . "/rem_iqegBCQb";
+	open $fh, ">$filename" or die "Cannot open $filename";
+	$stats = stat($file1);
+	# ($fh, $filename) = tempfile(UNLINK => 1);
+    } else {
+	open $fh, ">$file1" or die "Cannot open file $file1 for write: $!";
+    }
+    autoflush $fh 1;
+    while (<FH>) {
+	if ($_ =~ /^-----BEGIN PGP SIGNED MESSAGE-----/) {
+	    $sigstart = 1;
+	    $bodystart = 0;
+	    next;
+	} elsif (($sigstart == 1) && ($_ =~ /^\s+$/)) {
+	    $sigstart = 0;
+	    $bodystart = 1;
+	    next;
+	} elsif ($_ =~ /^-----BEGIN PGP SIGNATURE-----/) {
+	    $bodystart = 0;
+	    $sigend = 1;
+	    next;
+	} elsif (($sigend == 1) && ($_ =~ /^-----END PGP SIGNATURE-----/)) {
+	    $sigend = 0;
+	    $bodystart = 1;
+	    next;
+	}
+	if ($bodystart == 1) {
+	    print $fh $_;
+	}
+    }
+    if (!($file1 =~ /^\-$/)) {
+	my $command = "cp $filename $file1";
+	system ($command) == 0
+	    or die "system $command failed: $?";
+	chmod $stats->mode, $file1;
+	chown $stats->uid, $stats->gid, $file1;
+    }
+    unlink0( $fh, $filename ) or die "Cannot unlink $filename safely";
+    return;
+}
+
+sub print_cfgfile () {
+    my $bodystart = 0;
+    my $sigstart  = 0;
+
+    if (!defined($file2)) {
+	$file2 = '-';
+    }
+
+    open FH, "<$file1" or die "Cannot open file $file1 for read: $!";
+    open FO, ">$file2" or die "Cannot open file $file2 for write: $!";
+    while (<FH>) {
+	if ($_ =~ /^-----BEGIN PGP SIGNED MESSAGE-----/) {
+	    $sigstart = 1;
+	    next;
+	} elsif (($sigstart == 1) && ($_ =~ /^\s+$/)) {
+	    $sigstart = 0;
+	    $bodystart = 1;
+	    next;
+	} elsif ($_ =~ /^-----BEGIN PGP SIGNATURE-----/) {
+	    $bodystart = 0;
+	    exit;
+	}
+	if ($bodystart == 1) {
+	    print FO $_;
+	}
+    }
+    exit;
+}
+sub print_datafile () {
+    die ("Cannot find program $daemon") 
+	unless (-e $daemon);
+    if (defined($opts{'v'})) {
+	open FH, "$daemon --full-detail -d $datafile |" 
+	    or die "Cannot open datafile $datafile for read: $!";
+    } else {
+	open FH, "$daemon -d $datafile |" 
+	    or die "Cannot open datafile $datafile for read: $!";
+    }
+    while (<FH>) {
+	print $_;
+    }
+    exit;
+}
+
+sub sign_file () {
+
+    my $fileout = '';
+    my $bodystart = 1;
+    my $sigstart  = 0;
+    my $sigend    = 0;
+    my $stats;
+    my $fh1;
+    my $filename1;
+    my $flag1     = 0;
+
+    check_gpg_uid();
+
+    if (!defined($file2)) {
+	$file2 = $file1;
+    }
+
+    if ($file1 =~ /^\-$/) {
+	my $dir = tempdir( CLEANUP => 1 ) or die "Tempdir failed";
+	$filename1 = $dir . "/sig_vs8827sd";
+	open $fh1, ">$filename1" or die "Cannot open $filename1";
+	$flag1 = 1;
+	# my ($fh1, $filename1) = tempfile(UNLINK => 1);
+
+	while (<STDIN>) {
+	  if ($_ =~ /^-----BEGIN PGP SIGNED MESSAGE-----/) {
+	    $sigstart = 1;
+	    $bodystart = 0;
+	    next;
+	  } elsif (($sigstart == 1) && ($_ =~ /^\s+$/)) {
+	    $sigstart = 0;
+	    $bodystart = 1;
+	    next;
+	  } elsif ($_ =~ /^-----BEGIN PGP SIGNATURE-----/) {
+	    $bodystart = 0;
+	    $sigend = 1;
+	    next;
+	  } elsif (($sigend == 1) && ($_ =~ /^-----END PGP SIGNATURE-----/)) {
+	    $sigend = 0;
+	    $bodystart = 1;
+	    next;
+	  }
+	  if ($bodystart == 1) {
+	    print $fh1 $_;
+	  }
+	  #
+	  # print $fh1 $_;
+	  #
+	}
+	$file1 = $filename1;
+	$fileout = '-';
+    } else {
+	$no_print_examine = 1;
+	if (examine() < 2) {
+	    remove();
+	}
+	$fileout = $file1 . ".asc";
+	$stats   = stat($file1);
+    }
+
+    if (defined($passphrase)) {
+	local $SIG{PIPE} = 'IGNORE';
+	my $command = "$gpg --homedir $ENV{'HOME'}/.gnupg --passphrase-fd 0 -a --clearsign -o $fileout --not-dash-escaped $file1";
+	open (FH, "|$command")  or die "can't fork: $!";
+	print FH "$passphrase"  or die "can't write: $!";
+	close FH                or die "can't close: status=$?";
+    } else {
+	my $command = "$gpg --homedir $ENV{'HOME'}/.gnupg                   -a --clearsign -o $fileout --not-dash-escaped $file1";
+	system("$command") == 0 
+	    or die "system $command failed: $?";
+    }
+
+    if (!($fileout =~ /^\-$/)) {
+	my $st_old = stat($file1) 
+	    or die "No file $file1: $!";
+	my $st_new = stat($fileout) 
+	    or die "No file $fileout: $!";
+	die ("Signed file is smaller than unsigned file") 
+	    unless ($st_new->size > $st_old->size);
+	system ("mv $fileout $file2") == 0
+	    or die "system mv $fileout $file2 failed: $?";
+	chmod $stats->mode, $file2;
+	chown $stats->uid, $stats->gid, $file2;
+    }
+
+    if ($flag1 == 1) {
+	unlink0( $fh1, $filename1 ) or die "Cannot unlink $filename1 safely";
+    }
+    if ($return_from_sign == 1) {
+	return;
+    }
+    exit;
+}
+
+Getopt::Long::Configure ("posix_default");
+Getopt::Long::Configure ("bundling");
+# Getopt::Long::Configure ("debug");
+
+GetOptions (\%opts, 'm=s', 'h|help', 'v|verbose', 'l|list',
+	    'c|cfgfile=s',
+	    'd|datafile=s',
+	    'p|passphrase=s',
+	    'create-cfgfile',  # -m F
+	    'print-cfgfile',   # -m f
+	    'create-datafile', # -m D
+	    'print-datafile',  # -m d
+	    'remove-signature',# -m R
+	    'sign',            # -m E
+	    'examine',         # -m e
+	    'generate-keys');  # -m G
+
+if (defined ($opts{'h'})) {
+    usage();
+    exit;
+}
+
+if (defined($opts{'c'})) {
+    $cfgfile = $opts{'c'};
+}
+if (defined($opts{'d'})) {
+    $datafile = $opts{'d'};
+}
+if (defined($opts{'p'})) {
+    $passphrase = $opts{'p'};
+}
+
+if (defined ($opts{'m'}) && ($opts{'m'} =~ /[FfDdREeG]{1}/) ) {
+    $action = $opts{'m'};
+}
+elsif (defined ($opts{'create-cfgfile'})) {
+    $action = 'F';
+}
+elsif (defined ($opts{'print-cfgfile'})) {
+    $action = 'f';
+}
+elsif (defined ($opts{'create-cfgfile'})) {
+    $action = 'D';
+}
+elsif (defined ($opts{'print-cfgfile'})) {
+    $action = 'd';
+}
+elsif (defined ($opts{'remove-signature'})) {
+    $action = 'R';
+}
+elsif (defined ($opts{'sign'})) {
+    $action = 'E';
+}
+elsif (defined ($opts{'examine'})) {
+    $action = 'e';
+}
+elsif (defined ($opts{'generate-keys'})) {
+    $action = 'G';
+}
+else {
+    usage();
+    die ("No valid action specified !");
+}
+
+if (defined($ARGV[0])) {
+    $file1 = $ARGV[0];
+} 
+if (defined($ARGV[1])) {
+    $file2 = $ARGV[1];
+} 
+
+
+if (($action =~ /[REe]{1}/) && !defined($file1)) {
+    usage();
+    die("Option -m $action requires a filename (or '-' for stdio)\n");
+}
+
+if ($action =~ /^F$/) {
+    if (!defined($file1)) {
+	$file1 = $cfgfile;
+    }
+    $file2 = $cfgfile;
+    sign_file ();
+}
+
+if ($action =~ /^D$/) {
+    if (!defined($file1)) {
+	$file1 = $datafile;
+    }
+    $file2 = $datafile;
+    sign_file ();
+}
+
+if ($action =~ /^R$/) {
+    # $file1 defined
+    my $i = 0;
+    while (defined($ARGV[$i])) {
+	$file1 = $ARGV[$i];
+	remove ();
+	++$i;
+    }
+}
+
+if ($action =~ /^E$/) {
+    # $file1 defined
+    # default: $file2 = $file1
+    check_gpg_sign();
+    my $i = 0;
+    while (defined($ARGV[$i])) {
+	$file1 = $ARGV[$i];
+	$file2 = $file1;
+	$return_from_sign = 1;
+	sign_file ();
+	++$i;
+    }
+}
+
+if ($action =~ /^e$/) {
+    # $file1 defined
+    # default: $file2 = stdout
+    check_gpg_verify();
+    my $i = 0;
+    while (defined($ARGV[$i])) {
+	print "\n";
+	$file1 = $ARGV[$i];
+	examine ();
+	++$i;
+	print "\n--------------------------------\n" if (defined($ARGV[$i]));
+    }
+}
+
+if ($action =~ /^f$/) {
+    $file1 = $cfgfile;
+    $file2 = "-";
+    print_cfgfile ();
+}
+
+if ($action =~ /^d$/) {
+    # $file1 irrelevant
+    if (defined($opts{'l'})) {
+	print_datafile ();
+    } else {
+	$file1 = $datafile;
+	$file2 = "-";
+	print_cfgfile ();
+    }
+}
+
+
+
Index: /trunk/scripts/samhainrc_update.sh
===================================================================
--- /trunk/scripts/samhainrc_update.sh	(revision 1)
+++ /trunk/scripts/samhainrc_update.sh	(revision 1)
@@ -0,0 +1,227 @@
+#!/bin/bash
+# ----------------------------------------------------------------------------- 
+# @brief: update the kernel options in the samhain configuration
+#         file, after a new kernel has been compiled
+# @author: marc heisterkamp <marzheister@web.de>
+# ----------------------------------------------------------------------------- 
+
+SAMHAIN_CFG="/etc/samhainrc"
+
+BLUE="[34;01m"
+CYAN="[36;01m"
+GREEN="[32;01m"
+DARK_GREEN="[32m"
+RED="[31;01m"
+PURPLE="[35;01m"
+WHITE="[37;01m"
+DARK_GRAY="[30;01m"
+LIGHT_GRAY="[37m"
+YELLOW="[33;01m"
+BROWN="[33m"
+OFF="[0m"
+
+
+SYSTEM_MAP=""
+new_cfg=''
+scriptname="$0"
+
+# global variables for system adresses (extracted from System.map)
+SYS_CALL=''
+SYS_CALL_TABLE=''
+PROC_ROOT=''
+PROC_ROOT_IOPS=''
+PROC_ROOT_LOOKUP=''
+
+# Make sure the user has root permissions
+if [ $UID -ne 0 ] ; then
+  echo "You must be root to run this script. Exiting."
+  exit 1
+fi
+
+
+#------------------------------------------------------------------------------
+# usage 
+#------------------------------------------------------------------------------
+function print_usage() {
+
+  cat >&2 <<EOHELP
+
+  update the samhainrc configuration file with new kernel system addresses
+  (i.e: after kernel compilation) by extracting these from the new System.map 
+  file
+
+  SYNOPSIS
+     $scriptname [ ${GREEN}--help${OFF} ]
+                           [ ${GREEN}--nocolor${OFF} ]
+                           [ ${GREEN}--print-only${OFF} ] <System.map>
+                           [ ${GREEN}--update${OFF} ]     <System.map>
+
+  OPTIONS
+     ${GREEN}-h${OFF} ${GREEN}--help${OFF}
+        Show help. 
+
+     ${GREEN}--nocolor${OFF}
+        Disable color hilighting for non ANSI-compatible terms.
+
+     ${GREEN}-p${OFF} ${GREEN}--print-only${OFF} <System.map>
+        Print the extracted system adresses and do not write them to the 
+        samhain configuration file. 
+
+     ${GREEN}-u${OFF} ${GREEN}--update${OFF} <System.map>
+        Update the samhainrc configuration file with new kernel system
+        addresses from the given System.map file 
+
+EOHELP
+ exit 0
+}
+
+
+#------------------------------------------------------------------------------
+# parses the command line options 
+# param in: all parameters given to the script 
+#------------------------------------------------------------------------------
+function parse_cmd_line() {
+
+  # parse the command-line
+  while [ -n "$1" ]; do
+    case "$1" in
+      --help|-h) 
+        print_usage
+        ;;
+      --nocolor|-n)
+        unset DARK_GREEN GREEN RED BROWN LIGHT_GRAY WHITE OFF 
+        ;;
+      --print-only|-p)
+        shift
+        SYSTEM_MAP="$1"
+        get_system_addresses
+        print_system_addresses
+        break
+        ;;
+      --update|-u)
+        shift
+        SYSTEM_MAP="$1"
+        get_system_addresses
+        print_system_addresses
+        replace_system_addresses
+        ;;
+      -*)
+        echo "$scriptname: unknown option $1. Exiting" >&2
+        exit 1
+        ;;
+    esac
+    shift
+  done
+}
+
+
+#------------------------------------------------------------------------------
+# extract system adresses from given System.map file and save to global
+# variables 
+#------------------------------------------------------------------------------
+function get_system_addresses() { 
+
+  if [ -z "$SYSTEM_MAP" ] ; then
+    echo
+    echo "No System.map specified. Exiting" >&2
+    echo
+    exit 1
+  fi
+
+  if [ ! -f "$SYSTEM_MAP" ] ; then
+    echo
+    echo "Could not find System.map: $SYSTEM_MAP. Exiting" >&2
+    echo
+    exit 1
+  fi
+
+  # 1. this is the address of system_call (grep system_call System.map) 
+  #    KernelSystemCall = 0xc0106cf8
+  SYS_CALL="0x`grep system_call $SYSTEM_MAP | cut -d' ' -f1`"
+
+  # 2. this is the address of sys_call_table (grep ' sys_call_table' System.map) 
+  #    KernelSyscallTable = 0xc01efb98
+  SYS_CALL_TABLE="0x`grep sys_call_table $SYSTEM_MAP | cut -d' ' -f1`"
+
+  # 3. this is the address of proc_root (grep ' proc_root$' System.map) 
+  #    KernelProcRoot = 0xc01efb98
+  PROC_ROOT="0x`grep ' proc_root$' $SYSTEM_MAP | cut -d' ' -f1`"
+
+  # 4. this is the address of proc_root_inode_operations 
+  #    (grep proc_root_inode_operations System.map) 
+  #    KernelProcRootIops = 0xc01efb98
+  PROC_ROOT_IOPS="0x`grep proc_root_inode_operations $SYSTEM_MAP | cut -d' ' -f1`"
+
+  # 5. this is the address of proc_root_lookup
+  #    (grep proc_root_lookup System.map) 
+  #    KernelProcRootLookup = 0xc01efb98
+  PROC_ROOT_LOOKUP="0x`grep proc_root_lookup $SYSTEM_MAP | cut -d' ' -f1`"
+}
+
+
+#------------------------------------------------------------------------------
+# extract system adresses from given System.map file and save to global
+# variables 
+#------------------------------------------------------------------------------
+function replace_system_addresses() { 
+
+  if [ -z "$SAMHAIN_CFG" ] ; then
+    echo "Could not find your samhainrc config file: $SAMHAIN_CFG. Exiting" >&2
+    exit 1
+  fi
+
+  echo
+  echo "Replacing current kernel system addresses in: $SAMHAIN_CFG"
+
+  # 1. replace current 'KernelSystemCall' setting
+  new_cfg=`sed -e "s/^\(KernelSystemCall[[:blank:]]*=\)[[:blank:]]*\(.*\)/\1 ${SYS_CALL}/" $SAMHAIN_CFG` 
+
+  # 2. replace current 'KernelSyscallTable' setting
+  new_cfg=`echo "$new_cfg" | sed -e "s/^\(KernelSyscallTable[[:blank:]]*=\)[[:blank:]]*\(.*\)/\1 ${SYS_CALL_TABLE}/"` 
+
+  # 3. replace current 'KernelProcRoot' setting
+  new_cfg=`echo "$new_cfg" | sed -e "s/^\(KernelProcRoot[[:blank:]]*=\)[[:blank:]]*\(.*\)/\1 ${PROC_ROOT}/"` 
+
+  # 4. replace current 'KernelProcRootIops' setting
+  new_cfg=`echo "$new_cfg" | sed -e "s/^\(KernelProcRootIops[[:blank:]]*=\)[[:blank:]]*\(.*\)/\1 ${PROC_ROOT_IOPS}/"` 
+
+  # 5. replace current 'KernelSystemCall' setting
+  new_cfg=`echo "$new_cfg" | sed -e "s/^\(KernelProcRootLookup[[:blank:]]*=\)[[:blank:]]*\(.*\)/\1 ${PROC_ROOT_LOOKUP}/"` 
+
+  echo "Backup old samhainrc $SAMHAIN_CFG to $SAMHAIN_CFG.bak"
+
+  # backup old samhainrc config file 
+  mv "$SAMHAIN_CFG" "$SAMHAIN_CFG.bak"
+
+  # write new samhainrc config file 
+  echo "$new_cfg" > "$SAMHAIN_CFG"
+
+  echo "Successfully updated kernel system addresses."
+  echo
+}
+
+
+#------------------------------------------------------------------------------
+# print samhain required system adresses 
+#------------------------------------------------------------------------------
+function print_system_addresses() {
+
+  echo 
+  echo "your kernel system addresses from: `basename $SYSTEM_MAP`"
+  echo 
+  echo "  KernelSystemCall     = $SYS_CALL"
+  echo "  KernelSyscallTable   = $SYS_CALL_TABLE"
+  echo "  KernelProcRoot       = $PROC_ROOT"
+  echo "  KernelProcRootIops   = $PROC_ROOT_IOPS"
+  echo "  KernelProcRootLookup = $PROC_ROOT_LOOKUP"
+  echo 
+
+}
+
+if [ $# -eq 0 ] ; then
+  print_usage
+fi
+
+parse_cmd_line $*
+
+exit 0
Index: /trunk/sql_init/samhain.mysql.init
===================================================================
--- /trunk/sql_init/samhain.mysql.init	(revision 584)
+++ /trunk/sql_init/samhain.mysql.init	(revision 1)
@@ -1,3 +1,5 @@
 CREATE DATABASE samhain;
+USE mysql;
+INSERT INTO db (Host,Db,User,Select_priv,Insert_priv,Update_priv,Delete_priv,Create_priv,Drop_priv) VALUES ('localhost','samhain','','N','Y','N','N','N','N');
 USE samhain;
 CREATE TABLE    samhain.log (
@@ -31,5 +33,5 @@
   	return_code   INTEGER,
   	syscall       VARCHAR(16),
-  	ip            VARCHAR(46),
+  	ip            VARCHAR(16),
   	tty           VARCHAR(16),
         peer          VARCHAR(64),
@@ -68,27 +70,23 @@
         link_new      BLOB,
 	
-        size_old      BIGINT UNSIGNED,
-        size_new      BIGINT UNSIGNED,
-        hardlinks_old BIGINT UNSIGNED,
-        hardlinks_new BIGINT UNSIGNED,
-        inode_old     BIGINT UNSIGNED,
-        inode_new     BIGINT UNSIGNED,
+        size_old      BIGINT,
+        size_new      BIGINT,
+        hardlinks_old BIGINT,
+        hardlinks_new BIGINT,
+        inode_old     BIGINT,
+        inode_new     BIGINT,
 
-	imode_old     BIGINT UNSIGNED,
-	imode_new     BIGINT UNSIGNED,
-	iattr_old     BIGINT UNSIGNED,
-	iattr_new     BIGINT UNSIGNED,
-	idevice_old   BIGINT UNSIGNED,
-	idevice_new   BIGINT UNSIGNED,
-	iowner_old    BIGINT UNSIGNED,
-	iowner_new    BIGINT UNSIGNED,
-	igroup_old    BIGINT UNSIGNED,
-	igroup_new    BIGINT UNSIGNED,
-	checkflags_old    BIGINT UNSIGNED,
-	checkflags_new    BIGINT UNSIGNED,
+	imode_old     BIGINT,
+	imode_new     BIGINT,
+	iattr_old     BIGINT,
+	iattr_new     BIGINT,
+	idevice_old   BIGINT,
+	idevice_new   BIGINT,
+	iowner_old    BIGINT,
+	iowner_new    BIGINT,
+	igroup_old    BIGINT,
+	igroup_new    BIGINT
 	
 
-        acl_old       BLOB,
-        acl_new       BLOB
                  
         );
Index: /trunk/sql_init/samhain.oracle.init
===================================================================
--- /trunk/sql_init/samhain.oracle.init	(revision 584)
+++ /trunk/sql_init/samhain.oracle.init	(revision 1)
@@ -9,5 +9,5 @@
         log_hash  VARCHAR2(32),
         entry_status  VARCHAR2(16) DEFAULT 'NEW' NOT NULL,
-        path          CLOB,         
+        path          VARCHAR2(4000),         
         userid        VARCHAR2(8),
         grp           VARCHAR2(8),
@@ -24,13 +24,13 @@
         return_code   INTEGER,
         syscall       VARCHAR2(16),
-        ip            VARCHAR2(46),
+        ip            VARCHAR2(16),
         tty           VARCHAR2(16),
         peer          VARCHAR2(64),
         fromhost      VARCHAR2(64),
-        obj           VARCHAR2(4000),
+        obj           VARCHAR2(128),
         interface     VARCHAR2(64),
         time          VARCHAR2(64),
-        dir           CLOB,
-        linked_path   CLOB,
+        dir           VARCHAR2(4000),
+        linked_path   VARCHAR2(4000),
         port          INTEGER,
         service       VARCHAR2(64),
@@ -56,6 +56,6 @@
         chksum_old    VARCHAR2(50),
         chksum_new    VARCHAR2(50),
-        link_old      CLOB,
-        link_new      CLOB,
+        link_old      VARCHAR2(4000),
+        link_new      VARCHAR2(4000),
         size_old      NUMBER(20),
         size_new      NUMBER(20),
@@ -73,10 +73,17 @@
         iowner_new    NUMBER(20),
         igroup_old    NUMBER(20),
-        igroup_new    NUMBER(20),
-        checkflags_old    NUMBER(20),
-        checkflags_new    NUMBER(20),
-        acl_old       VARCHAR2(4000),
-        acl_new       VARCHAR2(4000)
+        igroup_new    NUMBER(20)
         );
+
+CREATE OR REPLACE TRIGGER trigger_on_log
+before insert on log
+for each row
+declare
+log_index integer;
+begin
+select log_log_index_seq.NEXTVAL into :new.log_index from dual;
+end trigger_on_log;
+.
+run;
 
 CREATE UNIQUE INDEX log_log_index_key on log (log_index);
Index: /trunk/sql_init/samhain.postgres.init
===================================================================
--- /trunk/sql_init/samhain.postgres.init	(revision 584)
+++ /trunk/sql_init/samhain.postgres.init	(revision 1)
@@ -1,5 +1,5 @@
 CREATE SEQUENCE log_log_index_seq START 1;
 CREATE TABLE    log (
-	log_index INTEGER NOT NULL,
+	log_index INTEGER NOT NULL DEFAULT NEXTVAL('log_log_index_seq'),
 	log_ref   BIGINT NULL,
 	log_host  VARCHAR(64)   NOT NULL DEFAULT 'localhost',
@@ -27,5 +27,5 @@
   	return_code   INTEGER,
   	syscall       VARCHAR(16),
-  	ip            VARCHAR(46),
+  	ip            VARCHAR(16),
   	tty           VARCHAR(16),
         peer          VARCHAR(64),
@@ -64,26 +64,22 @@
         link_new      TEXT,
 	
-        size_old      NUMERIC(20),
-        size_new      NUMERIC(20),
-        hardlinks_old NUMERIC(20),
-        hardlinks_new NUMERIC(20),
-        inode_old     NUMERIC(20),
-        inode_new     NUMERIC(20),
+        size_old      BIGINT,
+        size_new      BIGINT,
+        hardlinks_old BIGINT,
+        hardlinks_new BIGINT,
+        inode_old     BIGINT,
+        inode_new     BIGINT,
 
-	imode_old     NUMERIC(20),
-	imode_new     NUMERIC(20),
-	iattr_old     NUMERIC(20),
-	iattr_new     NUMERIC(20),
-	idevice_old   NUMERIC(20),
-	idevice_new   NUMERIC(20),
-	iowner_old    NUMERIC(20),
-	iowner_new    NUMERIC(20),
-	igroup_old    NUMERIC(20),
-	igroup_new    NUMERIC(20),
-	checkflags_old    NUMERIC(20),
-	checkflags_new    NUMERIC(20),
+	imode_old     BIGINT,
+	imode_new     BIGINT,
+	iattr_old     BIGINT,
+	iattr_new     BIGINT,
+	idevice_old   BIGINT,
+	idevice_new   BIGINT,
+	iowner_old    BIGINT,
+	iowner_new    BIGINT,
+	igroup_old    BIGINT,
+	igroup_new    BIGINT
                  
-        acl_old       TEXT,
-        acl_new       TEXT
         );
 
Index: /trunk/src/bignum.c
===================================================================
--- /trunk/src/bignum.c	(revision 584)
+++ /trunk/src/bignum.c	(revision 1)
@@ -64,4 +64,9 @@
 #define ulong unsigned long
 
+/*
+extern void *malloc(size_t size);
+extern void free();
+*/
+
 char *last_string    = NULL;
 char *big_end_string = NULL;
@@ -175,5 +180,5 @@
     for (base = 2; base <= 36; base++)
     {
-	tmp = ((1U << (DIGIT_BITS - 1)) / base);
+	tmp = ((1 << (DIGIT_BITS - 1)) / base);
 	maxdigit = tmp * 2;
 	curdigit = 1;
@@ -209,7 +214,7 @@
   if (!dp) 
     return;
-  (void) count;
   free((char *)dp);
   dp = NULL;
+  count = 0;
 }
 #endif
@@ -227,5 +232,5 @@
     dgs_alloc += alloclen;
 #endif
-    digit_ptr = calloc(alloclen, sizeof(DIGIT));
+    digit_ptr = (DIGIT *) malloc(alloclen * sizeof(DIGIT));
     if (digit_ptr == NULL)
     {
@@ -425,5 +430,4 @@
 {
     DIGIT *a_ptr, *b_ptr;
-    int retval = 0;
 
     if (a->dgs_used  == b->dgs_used)
@@ -438,12 +442,10 @@
 	if (a_ptr < a->dp)
 	{
-	    return retval;
+	    return 0;
 	}
 	else
 	{
-	    if (retval == 0)
-	        retval = (*a_ptr > *b_ptr) ? 1 : -1;
-	}
-	return retval;
+	    return (*a_ptr > *b_ptr) ? 1 : -1;
+	}
     }
     return (a->dgs_used > b->dgs_used) ? 1 : -1;
@@ -623,5 +625,5 @@
     big_set_long((long)1, &big_one);
     length_last_string = 10;
-    if ((last_string = calloc(1,length_last_string)) == NULL)
+    if ((last_string = malloc(length_last_string)) == NULL)
     {
 	big_errno = BIG_MEMERR;
@@ -924,5 +926,5 @@
     if (a->sign == BIG_SIGN_MINUS)
     {
-      *n = -*n;
+	*n = -*n;;
     }
     return FALSE;
@@ -953,5 +955,5 @@
 	if (last_string != NULL)
 	  free(last_string);
-	if ((last_string = calloc(1,str_length)) == NULL)
+	if ((last_string = malloc(str_length)) == NULL)
 	{
 	    big_errno = BIG_MEMERR;
